
#ifndef __SERIAL_H__
#define __SERIAL_H__

// #################### Include header files #####################

#include <math.h>
#include <string.h>
#include <stdio.h>
#include <windows.h>

///////// header files for save text to debug program/////////////

#include <iostream.h>
#include <fstream.h>
#include <string.h>

#include <dinput.h> //JoyStick From DirectX/   in lib= winmm.lib /****

//#include "mmsystem.h" 


// ######## define COM PORT (Serial connection) ##################

#define COMPORT "COM1" 


// ##define Serial class for Robot Control and Communication with A/D board####

class Serial
{
  public:

    Serial();
    ~Serial();
    
	
	void Serial::RefreshControlInput (); //JOYSTICK CONTROL
	void GetJoystickSignal();

    void GetSensors();
	void NeuralPreprocessor();
	void ModularNeuralControl();
	void MotorCommand();


    
	//****Transfer function****///
	double sigmoid(double num);
 	double tanh(double num);



    //------ Serial Communication -------------//

    HANDLE hComp;                 //Handle for COM port           
    DCB dcb;                      //data structure taking data for communication                        
    int valReturn;                // To return value (result of communication)     
    char chBuff;                  //Buffer for sending and receiving data 
    unsigned long nReadPort;      // Read Input   
    unsigned long nWritePort;     //Write Output  

    //---- end Serial communication -----------//

     double JoystickX;
	 double JoystickY;
	 double JoystickZ;

	 double PressButton;
		 
	// --- Save text------------//
		ofstream saveFile1;
		ofstream saveFile2;
		ofstream saveFile3;
	//-------------------------//

    // --- Parameter set of Read sensory data from A/D convertor ------------//
    
	int counter;
	double  Sensor[18]; //  Sensor[10]; 
    double 	IRMR_outputLowpass;
	double 	IRML_outputLowpass;
	double  IRRP_outputLowpass;
	double  WalkingGain;
	int SpeedControlMax;


    // --- Parameter set of Neural Preprocessor ------------//
   
    //****First Module of Neural Preprocessor****///
	
	double WeightP1_Upsidedown_sensor;
	double WeightP1_P1;

	double BiaseP1;

	double activityP1;
	double outputP1;


	//****Second Module of Neural Preprocessor****///

	double WeightP9_IRSpeedControl;
	double WeightP9_P9;    //Self connection
  
	double BiasP9;  
   
	double activityP9;
	double outputP9;

	//****Third Module of Neural Preprocessor****///

    double WeightP2_IR;   //Connection from IR to P2
	double WeightP3_IR;   //Connection from IR to P3
	double WeightP2_P2;	  //Self connection
	double WeightP3_P3;	  //Self connection

	double BiasP2;
    double BiasP3;    

    double activityP2;  
    double activityP3; 
    double outputP2; 
    double outputP3;

     //****XNOR network****///

	double WeightP4_P2;   //Connection from P2 to P4
    double WeightP5_P2;   //Connection from P2 to P5
	double WeightP4_P3;   //Connection from P3 to P4
   	double WeightP5_P3;   //Connection from P3 to P5
    double WeightP6_P4;   //Connection from P4 to P6
	double WeightP6_P5;   //Connection from P5 to P6
   
	double 	BiasP4;   //Bias or stationary Input
	double  BiasP5;   //Bias or stationary Input
	double  BiasP6;	  //Bias or stationary Input

    double activityP4; 
	double activityP5;
	double activityP6;
	
    double outputP4; //  XNOR network
    double outputP5; //  XNOR network
	double outputP6; //  XNOR network
    

    //****Forth Module of Neural Preprocessor****///
    
	double AvergRightIR;
    double AvergLeftIR;

	double WeightP7_IR;   //Connection from IR to P7
	double WeightP8_IR;   //Connection from IR to P8
	double WeightP7_P7;	  //Self connection
	double WeightP8_P8;	  //Self connection
	double WeightP8_P7;    //Connection from P8 to P7
	double WeightP7_P8;    //Connection from P7 to P8

    double activityP7;  
    double activityP8; 
    double outputP7; 
    double outputP8; 


	double activity_HiddenL;  
    double activity_HiddenR;
	double output_HiddenL;
	double output_HiddenR;
   



	double I1;
	double I2;
	double I3;
	double I4;
	double I5;
    double I6;
	double I7; 
	double I8; 


	double Input;


    // --- Parameter set of Neural Locomotion Control ------------//
 
	//****CPG network****///

	double WeightH1_H1;  
	double WeightH2_H2;
	double WeightH1_H2;
	double WeightH2_H1;
	double BiasH1;
	double BiasH2;


	double activityH1;
	double activityH2;

	double outputH1;
	double outputH2;

   //****PSN ****///

	double WeightH3_I3; 
	double WeightH4_I3; 

   	double WeightH5_H1; 
   	double WeightH8_H1; 
	double WeightH6_H2; 
   	double WeightH7_H2;

	double WeightH5_H3;
	double WeightH7_H3;
	double WeightH6_H4;
	double WeightH8_H4;

	double WeightH9_H5;
	double WeightH10_H6;
	double WeightH11_H7;
	double WeightH12_H8;
	
	double WeightH13_H9;
	double WeightH13_H10;
	double WeightH14_H11;
	double WeightH14_H12;
	
	double BiasH3;
	double BiasH9;
	double BiasH10;
	double BiasH11;
	double BiasH12;
	double BiasH13;
	double BiasH14;


	double activityH3;
	double activityH4;

	double activityH5;
	double activityH6;
	double activityH7;
	double activityH8;

	double activityH9;
	double activityH10;
	double activityH11;
	double activityH12;

	double activityH13;
	double activityH14;

	double outputH3;
	double outputH4;
	double outputH5;
	double outputH6;
	double outputH7;
	double outputH8;
	double outputH9 ;
	double outputH10;
	double outputH11;
	double outputH12;
   	
	double outputH13;
 	double outputH14;

    
	//****VRNs ****///

	//-----------VRN1_L-------------------------------//

    double WeightH15_H14; //VRN1_L (Y input)
	double WeightH16_I4; //VRN1_L (X input)

    double WeightH19_H15;   //VRN1_L
    double WeightH20_H15;   //VRN1_L
    double WeightH21_H15;   //VRN1_L
	double WeightH22_H15;   //VRN1_L

	double WeightH19_H16;   //VRN1_L
	double WeightH20_H16;   //VRN1_L
	double WeightH21_H16;   //VRN1_L
   	double WeightH22_H16;   //VRN1_L

	double WeightH27_H19;   //VRN1_L
	double WeightH27_H20;   //VRN1_L
	double WeightH27_H21;   //VRN1_L
	double WeightH27_H22;   //VRN1_L

	double BiasH19;
    double BiasH20;
	double BiasH21;
	double BiasH22;	


	double activityH15;
	double activityH16; //*****Input4

	double activityH19;
    double activityH20;
	double activityH21;
	double activityH22;

    double activityH27;

    double outputH15;
	double outputH16;

	double outputH19;
	double outputH20;
	double outputH21;
	double outputH22;

	double outputH27;

	 //-----------VRN2_R-------------------------------//

	double WeightH17_H14; //VRN2_R (Y input)
	double WeightH18_I5; //VRN1_R (X input)

	double WeightH23_H17;   //VRN2_R
    double WeightH24_H17;  //VRN2_R
    double WeightH25_H17;   //VRN2_R
	double WeightH26_H17;  //VRN2_R

	double WeightH23_H18;   //VRN2_R
	double WeightH24_H18;   //VRN2_R
	double WeightH25_H18;   //VRN2_R
   	double WeightH26_H18;   //VRN2_R

	double WeightH28_H23;   //VRN2_R
	double WeightH28_H24;   //VRN2_R
	double WeightH28_H25;   //VRN2_R
	double WeightH28_H26;   //VRN2_R

	double BiasH23;
    double BiasH24;
	double BiasH25;
	double BiasH26;

    
	double activityH17;
	double activityH18; //*****Input5



	double activityH23;
    double activityH24;
	double activityH25;
	double activityH26;

    double activityH28;

    
	double outputH17;
	double outputH18;
	
	double outputH23;
	double outputH24;
	double outputH25;
	double outputH26;

	double outputH28;


	// --- Parameter set of Neural Control------------//
	// Neural controller for 6 legs walking machines and 3 DOFs each leg , 1 backbone joint and 2 tail joitns

   	//----------FL,R joints-------//

   	double WeightFL1_H13; 
	double WeightFL2_H13; 
	double WeightFL3_H13; 

	double WeightFR1_H13; 
	double WeightFR2_H13; 
	double WeightFR3_H13; 
    
	double WeightFL1_I1; 
	double WeightFL2_I1; 
	double WeightFL3_I1; 

	double WeightFR1_I1; 
	double WeightFR2_I1; 
	double WeightFR3_I1; 

	double WeightFL1_I2; 
	double WeightFL2_I2; 
	double WeightFL3_I2; 

	double WeightFR1_I2; 
	double WeightFR2_I2; 
	double WeightFR3_I2; 

	double BiasFL1;
	double BiasFL2;
	double BiasFL3;

	double BiasFR1;
	double BiasFR2;
	double BiasFR3;

	//---------CL,R joints----------//

	double WeightCL1_H14; 
	double WeightCL2_H14; 
	double WeightCL3_H14; 

	double WeightCR1_H14; 
	double WeightCR2_H14; 
	double WeightCR3_H14; 

	double WeightCL1_I1; 
	double WeightCL2_I1; 
	double WeightCL3_I1; 

	double WeightCR1_I1; 
	double WeightCR2_I1; 
	double WeightCR3_I1;

	double BiasCL1;
	double BiasCL2;
	double BiasCL3;

	double BiasCR1;
	double BiasCR2;
	double BiasCR3;


	double outputCR1old ;
	double outputCR2old ;
	double outputCR3old ;
	double outputCL1old ;
	double outputCL2old ;
	double outputCL3old ;

	double outCR1 ;
	double outCR2 ;
	double outCR3 ;
	double outCL1 ;
	double outCL2 ;
	double outCL3 ;
 	
	//---------TL,R joints----------//
  
	double WeightTL1_H27;
	double WeightTL2_H27;
	double WeightTL3_H27;

	double WeightTR1_H28;
	double WeightTR2_H28;
	double WeightTR3_H28;

	double WeightTL1_I1; 
	double WeightTL2_I1; 
	double WeightTL3_I1; 

	double WeightTR1_I1; 
	double WeightTR2_I1; 
	double WeightTR3_I1;

	
	double WeightBJ_H14; //BJ
	double BiasBJ;// BJ motor 18

	double WeightLT_H14; //Lower tail
	double BiasLT;// BJ motor 19

	double WeightUT_H14; //Upper tail
	double BiasUT;// BJ motor 20


	double activityFL1;
    double activityFL2;
	double activityFL3;

    double activityFR1;
    double activityFR2;
	double activityFR3;

	double activityCL1;
	double activityCL2;
	double activityCL3;

	double activityCR1;
	double activityCR2;
	double activityCR3;


	double activityTL1;
	double activityTL2;
	double activityTL3;

	double activityTR1;
	double activityTR2;
	double activityTR3;


		
	
	//MID motors
	double activityBJ;

	//lower tail 
	double activityLT;
	double WeightLT_I1;

	//upper tail
	double activityUT;
	double WeightUT_I1;


	double outputFL1;
	double outputFL2;
	double outputFL3;

	double outputFR1;
	double outputFR2;
	double outputFR3;

	double outputCL1;
	double outputCL2;
	double outputCL3;

	double outputCR1;
	double outputCR2;
	double outputCR3;

	double outputTL1;
	double outputTL2;
	double outputTL3;

	double outputTR1;
	double outputTR2;
	double outputTR3;

	double outputBJ;
	double outputLT;
	double outputUT;

    // --- Parameter set of Motor command ------------//

    int servoPosMin[21];
	int servoPosMax[21];
	double motorCom[21];


   // --- End ------------//

};

#endif // __SERIALMORPHEUS_H__
