////////////////////////////////////////////////////
// Main function of Sensor-Driven Neural Controller
// The controller is described in the paper
// Manoonpong, P.; Pasemann, F.; Woergoetter, F. (2007) 
// Sensor-Driven Neural Control for Omnidirectional Locomotion 
// and Versatile Reactive Behaviors of Walking Machines. Robotics 
// and Autonomous Systems, Elsevier Science, in press.


// Created by P.Manoonpong
////////////////////////////////////////////



///////Serial Communication////////////////
#include "Sensor-DrivenNeuralController.h"
#include <string.h>
#include <stdio.h>
///////////////////////////////////////////

#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>


Serial* robot;

int main (int argc, char **argv)
{


	/////define parameters///////////////////////
	int counter;

	///Reading Time//////////////////////
	struct timeval start_time, end_time;
	char tmpbuf[128], ampm[] = "AM";
	time_t ltime;
	struct _timeb tstruct;
	long t1, difftime,t2;
	///End Reading Time/////////////////


	robot = new Serial();	
	/////End Initial parameters////////////////////


	do{



	//Read time to calculate update frequency	
	_ftime(&tstruct);

	t1 = tstruct.time*1000+tstruct.millitm; //Start time

	/////////////////////////////////////////



    //////////////Control Architecture////////////////////////////////////////////////////



	       //****************Input signals coming from Joystick or Sensors to control walking patterns*****************************//

			//--update frequency at about 70 Hz (67.7Hz)---//
		   
		   //*******Using Joystick, Reading Joystick input***//
	       // robot->RefreshControlInput ();
	       // robot->GetJoystickSignal(); // Read sensory data from USB Joystick, Activate this function for using joystick input
		   //*******************************************************//



		   //*******Using Sensors, Reading sensor input***//
			robot->GetSensors(); //Read sensory data from A/D convertor, e.g. here  MBoard
			robot->NeuralPreprocessor();//Preprocessing sensory signal, e.g. here neural preprocessor, Activate this function for sensor inputs
           //*******************************************************//


           //*********************************************************************************************************************//



		   //****************Modular neural locomotion control********************************************************************//

			//--update frequency of Motor Command at about 25 Hz (22.6 Hz) if set counter%3---//
			//--update frequency at Motor Command at about 70 Hz if set counter%1---//

			counter++;

			if (counter%3==0){
        	robot->ModularNeuralControl();//Locomotion control, e.g. here modular neural control 
			robot->MotorCommand();
				
			}

		   //*********************************************************************************************************************//


   //////////////End Control Architecture/////////////////////////////////////////////////


     

	//Read time to calculate update frequency	
	_ftime(&tstruct);

	t2 = tstruct.time*1000+tstruct.millitm; //End time
	/////////////////////////////////////////

	difftime = t2-t1;

    //printf( "Plusdifff milliseconds:\t\t\t%u\n",difftime);
		
    //Or check Update freq by recoard data in one min = number of data/60 = Hz

	}while(1==1);

  return 0;
}